﻿' هذا المثال كتبه م. محمد حمدي غانم، وهو أحد أمثلة كتاب 
' من الصفر إلى الاحتراف: برمجة نماذج الويندوز في سي شارب 2010
' الناشر: مكتبة دار المعرفة، 4 شارع السرايات
' أمام هندسة عين شمس ـ بالقرب من ميدان عبده باشا ـ العباسية ـ القاهرة، 
' هاتف 26844043 
' بريد إلكتروني: dar_elmaarefa@yahoo.com

Imports Microsoft.VisualBasic.PowerPacks

Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'TODO: This line of code loads data into the 'BooksDataSet.Books' table. You can move, or remove it, as needed.
        Me.BooksTableAdapter.Fill(Me.BooksDataSet.Books)
        'TODO: This line of code loads data into the 'BooksDataSet.Authors' table. You can move, or remove it, as needed.
        Me.AuthorsTableAdapter.Fill(Me.BooksDataSet.Authors)
        Dim Fkc As New ForeignKeyConstraint(BooksDataSet.Authors.IDColumn, BooksDataSet.Books.AuthorIDColumn)
        Fkc.UpdateRule = Rule.Cascade
        Fkc.AcceptRejectRule = Rule.Cascade
        Fkc.DeleteRule = Rule.Cascade
        BooksDataSet.Books.Constraints.Add(Fkc)
        DataRepeater1.ItemCount = BooksDataSet.Authors.Count
    End Sub

    Private Sub DataRepeater1_DrawItem(ByVal sender As Object, ByVal e As Microsoft.VisualBasic.PowerPacks.DataRepeaterItemEventArgs) Handles DataRepeater1.DrawItem
        Dim Itm = e.DataRepeaterItem
        Dim Rv = BooksDataSet.Authors.DefaultView(Itm.ItemIndex)
        Dim Rl = BooksDataSet.Authors.ChildRelations(0)
        Dim GrdBooks = CType(Itm.Controls("BooksDataGridView"), DataGridView)
        GrdBooks.DataSource = Rv.CreateChildView(Rl)
    End Sub

    Private Sub DataRepeater1_ItemsRemoved(ByVal sender As Object, ByVal e As Microsoft.VisualBasic.PowerPacks.DataRepeaterAddRemoveItemsEventArgs) Handles DataRepeater1.ItemsRemoved
        BooksDataSet.Authors.Rows.RemoveAt(e.ItemIndex)
    End Sub

    Private Sub DataRepeater1_ItemValueNeeded(ByVal sender As Object, ByVal e As Microsoft.VisualBasic.PowerPacks.DataRepeaterItemValueEventArgs) Handles DataRepeater1.ItemValueNeeded
        Try
            Select Case e.Control.Name
                Case "IDTextBox"
                    e.Value = BooksDataSet.Authors(e.ItemIndex).ID.ToString
                Case "AuthorTextBox"
                    e.Value = BooksDataSet.Authors(e.ItemIndex).Author.Trim
                Case "CountryIDTextBox"
                    e.Value = BooksDataSet.Authors(e.ItemIndex).CountryID.ToString
                Case "PhoneTextBox"
                    e.Value = BooksDataSet.Authors(e.ItemIndex).Phone
                Case "AboutTextBox"
                    e.Value = BooksDataSet.Authors(e.ItemIndex).About
            End Select
        Catch ex As Exception

        End Try
    End Sub

    Private Sub DataRepeater1_ItemValuePushed(ByVal sender As Object, ByVal e As Microsoft.VisualBasic.PowerPacks.DataRepeaterItemValueEventArgs) Handles DataRepeater1.ItemValuePushed
        Try
            Select Case e.Control.Name
                Case "AuthorTextBox"
                    BooksDataSet.Authors(e.ItemIndex).Author = e.Value.ToString.Trim
                Case "CountryIDTextBox"
                    BooksDataSet.Authors(e.ItemIndex).CountryID = e.Value
                Case "PhoneTextBox"
                    BooksDataSet.Authors(e.ItemIndex).Phone = e.Value
                Case "AboutTextBox"
                    BooksDataSet.Authors(e.ItemIndex).About = e.Value
            End Select
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub DataRepeater1_NewItemNeeded(ByVal sender As Object, ByVal e As System.EventArgs) Handles DataRepeater1.NewItemNeeded
        Dim R = BooksDataSet.Authors.NewAuthorsRow
        R.Author = " "
        R.CountryID = 12
        BooksDataSet.Authors.AddAuthorsRow(R)
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Try
            AuthorsTableAdapter.Update(BooksDataSet.Authors)
            BooksTableAdapter.Update(BooksDataSet.Books)
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub BooksDataGridView_DataError(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewDataErrorEventArgs) Handles BooksDataGridView.DataError
        Beep()
        e.Cancel = True
    End Sub
End Class
